/**
 * Generated by Apache Royale Compiler from org/apache/royale/test/RoyaleUnitCore.as
 * org.apache.royale.test.RoyaleUnitCore
 *
 * @fileoverview
 *
 * @suppress {checkTypes|accessControls}
 */

goog.provide('org.apache.royale.test.RoyaleUnitCore');
goog.provide('org.apache.royale.test.RoyaleUnitCore.ClassesRunner');
goog.provide('org.apache.royale.test.RoyaleUnitCore.RootRunNotifier');

goog.require('org.apache.royale.events.Event');
goog.require('org.apache.royale.events.EventDispatcher');
goog.require('org.apache.royale.test.runners.ITestRunner');
goog.require('org.apache.royale.test.runners.ParentRunner');
goog.require('org.apache.royale.test.runners.notification.Failure');
goog.require('org.apache.royale.test.runners.notification.IAsyncStartupRunListener');
goog.require('org.apache.royale.test.runners.notification.IRunListener');
goog.require('org.apache.royale.test.runners.notification.IRunNotifier');
goog.require('org.apache.royale.test.runners.notification.Result');
goog.require('org.apache.royale.test.runners.notification.RunNotifier');
goog.require('org.apache.royale.utils.Language');



/**
 * Constructor.
 * @constructor
 * @extends {org.apache.royale.events.EventDispatcher}
 */
org.apache.royale.test.RoyaleUnitCore = function() {
  org.apache.royale.test.RoyaleUnitCore.base(this, 'constructor');

this._listeners = org.apache.royale.utils.Language.synthVector('org.apache.royale.test.runners.notification.IRunListener')['coerce']([]);
};
goog.inherits(org.apache.royale.test.RoyaleUnitCore, org.apache.royale.events.EventDispatcher);


/**
 * Prevent renaming of class. Needed for reflection.
 */
goog.exportSymbol('org.apache.royale.test.RoyaleUnitCore', org.apache.royale.test.RoyaleUnitCore);


/**
 * @protected
 * @type {org.apache.royale.test.runners.ITestRunner}
 */
org.apache.royale.test.RoyaleUnitCore.prototype._runner = null;


/**
 * @protected
 * @type {Array.<org.apache.royale.test.runners.notification.IRunListener>}
 */
org.apache.royale.test.RoyaleUnitCore.prototype._listeners;


/**
 * Requests that the runner stops running the tests. Phrased politely
 * because the test that is currently running may not be interrupted
 * before completing.
 * @export
 */
org.apache.royale.test.RoyaleUnitCore.prototype.pleaseStop = function() {
  if (!this._runner) {
    return;
  }
  this._runner.pleaseStop();
};


/**
 * Adds a run listener.
 * @export
 * @param {org.apache.royale.test.runners.notification.IRunListener} listener
 */
org.apache.royale.test.RoyaleUnitCore.prototype.addListener = function(listener) {
  var /** @type {number} */ index = this._listeners.indexOf(listener);
  if (index !== -1) {
    return;
  }
  this._listeners.push(listener);
};


/**
 * Removes a run listener.
 * @export
 * @param {org.apache.royale.test.runners.notification.IRunListener} listener
 */
org.apache.royale.test.RoyaleUnitCore.prototype.removeListener = function(listener) {
  var /** @type {number} */ index = this._listeners.indexOf(listener);
  if (index === -1) {
    return;
  }
  this._listeners.splice(index, 1);
};


/**
 * @asprivate
 * @export
 * @param {org.apache.royale.test.runners.ITestRunner} runner
 */
org.apache.royale.test.RoyaleUnitCore.prototype.runRunner = function(runner) {
  if (this._runner) {
    throw new Error("Failed to run tests. Wait for previous test run to complete before starting again.");
  }
  this._runner = runner;
  var /** @type {boolean} */ allListenersReady = true;
  var /** @type {number} */ listenersLength = (this._listeners.length) >> 0;
  for (var /** @type {number} */ i = 0; i < listenersLength; i++) {
    var /** @type {org.apache.royale.test.runners.notification.IRunListener} */ listener = this._listeners[i];
    if (org.apache.royale.utils.Language.is(listener, org.apache.royale.test.runners.notification.IAsyncStartupRunListener)) {
      var /** @type {org.apache.royale.test.runners.notification.IAsyncStartupRunListener} */ asyncListener = org.apache.royale.utils.Language.as(listener, org.apache.royale.test.runners.notification.IAsyncStartupRunListener, true);
      if (!asyncListener.ready) {
        allListenersReady = false;
        asyncListener.addEventListener("ready", org.apache.royale.utils.Language.closure(this.asyncListener_readyHandler, this, 'asyncListener_readyHandler'));
        asyncListener.addEventListener("skip", org.apache.royale.utils.Language.closure(this.asyncListener_skipHandler, this, 'asyncListener_skipHandler'));
      }
    }
  }
  if (allListenersReady) {
    this.startRun();
  }
};


/**
 * @asprivate
 * @protected
 */
org.apache.royale.test.RoyaleUnitCore.prototype.startRun = function() {
  var /** @type {org.apache.royale.test.runners.ITestRunner} */ runner = this._runner;
  var /** @type {org.apache.royale.test.runners.notification.IRunNotifier} */ notifier = new org.apache.royale.test.RoyaleUnitCore.RootRunNotifier(org.apache.royale.utils.Language.closure(this.testRunFinished, this, 'testRunFinished'));
  var /** @type {number} */ listenersLength = (this._listeners.length) >> 0;
  for (var /** @type {number} */ i = 0; i < listenersLength; i++) {
    var /** @type {org.apache.royale.test.runners.notification.IRunListener} */ listener = this._listeners[i];
    notifier.addListener(this._listeners[i]);
  }
  try {
    this._runner.run(notifier);
  } catch (error) {
    notifier.fireTestFailure(new org.apache.royale.test.runners.notification.Failure(runner.description, error));
    this.finishRunner();
  }
};


/**
 * @asprivate
 * @export
 * @param {Object} testClass
 * @param {...} rest
 */
org.apache.royale.test.RoyaleUnitCore.prototype.runClasses = function(testClass, rest) {
  rest = Array.prototype.slice.call(arguments, 1);
  var /** @type {Array.<Object>} */ classes = org.apache.royale.utils.Language.synthVector('Class')['coerce']([]);
  var /** @type {number} */ classCount = (rest.length) >> 0;
  for (var /** @type {number} */ i = 0; i < classCount; i++) {
    var /** @type {*} */ item = rest[i];
    if (org.apache.royale.utils.Language.is(item, org.apache.royale.utils.Language.synthType('Class'))) {
      classes[i] = rest[i];
    } else {
      throw new Error("Not a class: " + item);
    }
  }
  classes.unshift(testClass);
  this.runRunner(new org.apache.royale.test.RoyaleUnitCore.ClassesRunner(classes));
};


/**
 * @asprivate
 * @protected
 */
org.apache.royale.test.RoyaleUnitCore.prototype.finishRunner = function() {
  this._runner = null;
  this.dispatchEvent(new org.apache.royale.events.Event(org.apache.royale.events.Event.COMPLETE));
};


/**
 * @asprivate
 * @protected
 * @param {org.apache.royale.test.runners.notification.Result} result
 */
org.apache.royale.test.RoyaleUnitCore.prototype.testRunFinished = function(result) {
  this.finishRunner();
};


/**
 * @asprivate
 * @protected
 */
org.apache.royale.test.RoyaleUnitCore.prototype.checkListenersReady = function() {
  var /** @type {boolean} */ allListenersReady = true;
  var /** @type {number} */ listenersLength = (this._listeners.length) >> 0;
  for (var /** @type {number} */ i = 0; i < listenersLength; i++) {
    var /** @type {org.apache.royale.test.runners.notification.IRunListener} */ listener = this._listeners[i];
    if (org.apache.royale.utils.Language.is(listener, org.apache.royale.test.runners.notification.IAsyncStartupRunListener)) {
      var /** @type {org.apache.royale.test.runners.notification.IAsyncStartupRunListener} */ asyncListener = org.apache.royale.utils.Language.as(listener, org.apache.royale.test.runners.notification.IAsyncStartupRunListener, true);
      if (asyncListener.ready) {
        asyncListener.removeEventListener("skip", org.apache.royale.utils.Language.closure(this.asyncListener_skipHandler, this, 'asyncListener_skipHandler'));
        asyncListener.removeEventListener("ready", org.apache.royale.utils.Language.closure(this.asyncListener_readyHandler, this, 'asyncListener_readyHandler'));
      } else {
        allListenersReady = false;
      }
    }
  }
  if (allListenersReady) {
    this.startRun();
  }
};


/**
 * @asprivate
 * @protected
 * @param {org.apache.royale.events.Event} event
 */
org.apache.royale.test.RoyaleUnitCore.prototype.asyncListener_skipHandler = function(event) {
  var /** @type {org.apache.royale.test.runners.notification.IAsyncStartupRunListener} */ listener = org.apache.royale.utils.Language.as(event.currentTarget, org.apache.royale.test.runners.notification.IAsyncStartupRunListener, true);
  listener.removeEventListener("skip", org.apache.royale.utils.Language.closure(this.asyncListener_skipHandler, this, 'asyncListener_skipHandler'));
  listener.removeEventListener("ready", org.apache.royale.utils.Language.closure(this.asyncListener_readyHandler, this, 'asyncListener_readyHandler'));
  this.removeListener(listener);
  this.checkListenersReady();
};


/**
 * @asprivate
 * @protected
 * @param {org.apache.royale.events.Event} event
 */
org.apache.royale.test.RoyaleUnitCore.prototype.asyncListener_readyHandler = function(event) {
  this.checkListenersReady();
};


/**
 * Metadata
 *
 * @type {Object.<string, Array.<Object>>}
 */
org.apache.royale.test.RoyaleUnitCore.prototype.ROYALE_CLASS_INFO = { names: [{ name: 'RoyaleUnitCore', qName: 'org.apache.royale.test.RoyaleUnitCore', kind: 'class' }] };



/**
 * Reflection
 *
 * @return {Object.<string, Function>}
 */
org.apache.royale.test.RoyaleUnitCore.prototype.ROYALE_REFLECTION_INFO = function () {
  return {
    methods: function () {
      return {
        'RoyaleUnitCore': { type: '', declaredBy: 'org.apache.royale.test.RoyaleUnitCore'},
        'pleaseStop': { type: 'void', declaredBy: 'org.apache.royale.test.RoyaleUnitCore'},
        'addListener': { type: 'void', declaredBy: 'org.apache.royale.test.RoyaleUnitCore', parameters: function () { return [ 'org.apache.royale.test.runners.notification.IRunListener', false ]; }},
        'removeListener': { type: 'void', declaredBy: 'org.apache.royale.test.RoyaleUnitCore', parameters: function () { return [ 'org.apache.royale.test.runners.notification.IRunListener', false ]; }},
        'runRunner': { type: 'void', declaredBy: 'org.apache.royale.test.RoyaleUnitCore', parameters: function () { return [ 'org.apache.royale.test.runners.ITestRunner', false ]; }},
        'runClasses': { type: 'void', declaredBy: 'org.apache.royale.test.RoyaleUnitCore', parameters: function () { return [ 'Class', false ,'Array', false ]; }}
      };
    }
  };
};
/**
 * @const
 * @type {number}
 */
org.apache.royale.test.RoyaleUnitCore.prototype.ROYALE_COMPILE_FLAGS = 10;



/**
 * Constructor.
 * @constructor
 * @extends {org.apache.royale.test.runners.ParentRunner}
 * @implements {org.apache.royale.test.runners.ITestRunner}
 * @param {Array.<Object>} classes
 */
org.apache.royale.test.RoyaleUnitCore.ClassesRunner = function(classes) {
  org.apache.royale.test.RoyaleUnitCore.ClassesRunner.base(this, 'constructor');
  if (!classes) {
    throw new Error("Test classes collection must not be null.");
  }
  this.ClassesRunner__classes = classes;
};
goog.inherits(org.apache.royale.test.RoyaleUnitCore.ClassesRunner, org.apache.royale.test.runners.ParentRunner);


/**
 * Prevent renaming of class. Needed for reflection.
 */
goog.exportSymbol('org.apache.royale.test.RoyaleUnitCore.ClassesRunner', org.apache.royale.test.RoyaleUnitCore.ClassesRunner);


/**
 * @private
 * @type {Array.<Object>}
 */
org.apache.royale.test.RoyaleUnitCore.ClassesRunner.prototype.ClassesRunner__classes = null;


/**
 * @asprivate
 * @protected
 * @override
 */
org.apache.royale.test.RoyaleUnitCore.ClassesRunner.prototype.collectChildren = function(result) {
  if (!this.ClassesRunner__classes) {
    return;
  }
  var /** @type {number} */ classCount = (this.ClassesRunner__classes.length) >> 0;
  for (var /** @type {number} */ i = 0; i < classCount; i++) {
    result.push(this.ClassesRunner__classes[i]);
  }
};


org.apache.royale.test.RoyaleUnitCore.ClassesRunner.prototype.get__description = function() {
  return "RoyaleUnitCore";
};


Object.defineProperties(org.apache.royale.test.RoyaleUnitCore.ClassesRunner.prototype, /** @lends {org.apache.royale.test.RoyaleUnitCore.ClassesRunner.prototype} */ {
/**
  * @export
  * @type {string} */
description: {
get: org.apache.royale.test.RoyaleUnitCore.ClassesRunner.prototype.get__description}}
);


/**
 * Metadata
 *
 * @type {Object.<string, Array.<Object>>}
 */
org.apache.royale.test.RoyaleUnitCore.ClassesRunner.prototype.ROYALE_CLASS_INFO = { names: [{ name: 'ClassesRunner', qName: 'org.apache.royale.test.RoyaleUnitCore.ClassesRunner', kind: 'class' }], interfaces: [org.apache.royale.test.runners.ITestRunner] };



/**
 * Reflection
 *
 * @return {Object.<string, Function>}
 */
org.apache.royale.test.RoyaleUnitCore.ClassesRunner.prototype.ROYALE_REFLECTION_INFO = function () {
  return {
    accessors: function () {
      return {
        'description': { type: 'String', access: 'readonly', declaredBy: 'org.apache.royale.test.RoyaleUnitCore.ClassesRunner'}
      };
    },
    methods: function () {
      return {
        'ClassesRunner': { type: '', declaredBy: 'org.apache.royale.test.RoyaleUnitCore.ClassesRunner', parameters: function () { return [ 'Vector.<Class>', false ]; }}
      };
    }
  };
};
/**
 * @const
 * @type {number}
 */
org.apache.royale.test.RoyaleUnitCore.ClassesRunner.prototype.ROYALE_COMPILE_FLAGS = 10;



/**
 * @constructor
 * @extends {org.apache.royale.test.runners.notification.RunNotifier}
 * @param {Function} testRunFinishedCallback
 */
org.apache.royale.test.RoyaleUnitCore.RootRunNotifier = function(testRunFinishedCallback) {
  org.apache.royale.test.RoyaleUnitCore.RootRunNotifier.base(this, 'constructor');
  this.RootRunNotifier__testRunFinishedCallback = testRunFinishedCallback;
};
goog.inherits(org.apache.royale.test.RoyaleUnitCore.RootRunNotifier, org.apache.royale.test.runners.notification.RunNotifier);


/**
 * Prevent renaming of class. Needed for reflection.
 */
goog.exportSymbol('org.apache.royale.test.RoyaleUnitCore.RootRunNotifier', org.apache.royale.test.RoyaleUnitCore.RootRunNotifier);


/**
 * @private
 * @type {Function}
 */
org.apache.royale.test.RoyaleUnitCore.RootRunNotifier.prototype.RootRunNotifier__testRunFinishedCallback = null;


/**
 * @export
 * @override
 */
org.apache.royale.test.RoyaleUnitCore.RootRunNotifier.prototype.fireTestRunFinished = function(result) {
  org.apache.royale.test.RoyaleUnitCore.RootRunNotifier.superClass_.fireTestRunFinished.apply(this, [ result] );
  this.RootRunNotifier__testRunFinishedCallback(result);
};


/**
 * Metadata
 *
 * @type {Object.<string, Array.<Object>>}
 */
org.apache.royale.test.RoyaleUnitCore.RootRunNotifier.prototype.ROYALE_CLASS_INFO = { names: [{ name: 'RootRunNotifier', qName: 'org.apache.royale.test.RoyaleUnitCore.RootRunNotifier', kind: 'class' }] };



/**
 * Reflection
 *
 * @return {Object.<string, Function>}
 */
org.apache.royale.test.RoyaleUnitCore.RootRunNotifier.prototype.ROYALE_REFLECTION_INFO = function () {
  return {
    methods: function () {
      return {
        'RootRunNotifier': { type: '', declaredBy: 'org.apache.royale.test.RoyaleUnitCore.RootRunNotifier', parameters: function () { return [ 'Function', false ]; }},
        'fireTestRunFinished': { type: 'void', declaredBy: 'org.apache.royale.test.RoyaleUnitCore.RootRunNotifier', parameters: function () { return [ 'org.apache.royale.test.runners.notification.Result', false ]; }}
      };
    }
  };
};
/**
 * @const
 * @type {number}
 */
org.apache.royale.test.RoyaleUnitCore.RootRunNotifier.prototype.ROYALE_COMPILE_FLAGS = 10;