/**
 * Generated by Apache Royale Compiler from org/apache/royale/test/async/AsyncLocator.as
 * org.apache.royale.test.async.AsyncLocator
 *
 * @fileoverview
 *
 * @suppress {checkTypes|accessControls}
 */

goog.provide('org.apache.royale.test.async.AsyncLocator');
goog.provide('org.apache.royale.test.async.AsyncLocator.MISSING_ASYNC_ERROR_MESSAGE');

goog.require('org.apache.royale.test.AssertionError');
goog.require('org.apache.royale.test.async.IAsyncHandler');
goog.require('org.apache.royale.utils.Language');



/**
 * @constructor
 */
org.apache.royale.test.async.AsyncLocator = function() {
};


/**
 * Prevent renaming of class. Needed for reflection.
 */
goog.exportSymbol('org.apache.royale.test.async.AsyncLocator', org.apache.royale.test.async.AsyncLocator);


/**
 * @private
 * @type {Map}
 */
org.apache.royale.test.async.AsyncLocator.handlers = new Map();


/**
 * Called by the test runner before an async test has started.
 * @export
 * @param {Object} test
 * @param {org.apache.royale.test.async.IAsyncHandler} handler
 */
org.apache.royale.test.async.AsyncLocator.setAsyncHandlerForTest = function(test, handler) {
  org.apache.royale.test.async.AsyncLocator.handlers.set(test, handler);
};


/**
 * Returns the current async handler for the specified test, or throws
 * an exception if there is none.
 * @export
 * @param {Object} test
 * @return {org.apache.royale.test.async.IAsyncHandler}
 */
org.apache.royale.test.async.AsyncLocator.getAsyncHandlerForTest = function(test) {
  if (!org.apache.royale.test.async.AsyncLocator.handlers || !org.apache.royale.test.async.AsyncLocator.hasAsyncHandlerForTest(test)) {
    throw new org.apache.royale.test.AssertionError(org.apache.royale.test.async.AsyncLocator.MISSING_ASYNC_ERROR_MESSAGE);
  }
  return org.apache.royale.utils.Language.as(org.apache.royale.test.async.AsyncLocator.handlers.get(test), org.apache.royale.test.async.IAsyncHandler, true);
};


/**
 * Called by the test runner after an async test has completed.
 * @export
 * @param {Object} test
 */
org.apache.royale.test.async.AsyncLocator.clearAsyncHandlerForTest = function(test) {
  if (!org.apache.royale.test.async.AsyncLocator.handlers || !org.apache.royale.test.async.AsyncLocator.hasAsyncHandlerForTest(test)) {
    return;
  }
  org.apache.royale.test.async.AsyncLocator.handlers.delete(test);
};


/**
 * Indicates if there is an async handler for the specified test.
 * @export
 * @param {Object} test
 * @return {boolean}
 */
org.apache.royale.test.async.AsyncLocator.hasAsyncHandlerForTest = function(test) {
  return org.apache.royale.test.async.AsyncLocator.handlers.has(test);
};


/**
 * Metadata
 *
 * @type {Object.<string, Array.<Object>>}
 */
org.apache.royale.test.async.AsyncLocator.prototype.ROYALE_CLASS_INFO = { names: [{ name: 'AsyncLocator', qName: 'org.apache.royale.test.async.AsyncLocator', kind: 'class' }] };



/**
 * Reflection
 *
 * @return {Object.<string, Function>}
 */
org.apache.royale.test.async.AsyncLocator.prototype.ROYALE_REFLECTION_INFO = function () {
  return {
    methods: function () {
      return {
        '|setAsyncHandlerForTest': { type: 'void', declaredBy: 'org.apache.royale.test.async.AsyncLocator', parameters: function () { return [ 'Object', false ,'org.apache.royale.test.async.IAsyncHandler', false ]; }},
        '|getAsyncHandlerForTest': { type: 'org.apache.royale.test.async.IAsyncHandler', declaredBy: 'org.apache.royale.test.async.AsyncLocator', parameters: function () { return [ 'Object', false ]; }},
        '|clearAsyncHandlerForTest': { type: 'void', declaredBy: 'org.apache.royale.test.async.AsyncLocator', parameters: function () { return [ 'Object', false ]; }},
        '|hasAsyncHandlerForTest': { type: 'Boolean', declaredBy: 'org.apache.royale.test.async.AsyncLocator', parameters: function () { return [ 'Object', false ]; }}
      };
    }
  };
};
/**
 * @const
 * @type {number}
 */
org.apache.royale.test.async.AsyncLocator.prototype.ROYALE_COMPILE_FLAGS = 10;



/**
 * @const
 * @type {string}
 */
org.apache.royale.test.async.AsyncLocator.MISSING_ASYNC_ERROR_MESSAGE = "Cannot add asynchronous functionality to methods defined by Test, Before, or After that are not marked async"