/**
 * Generated by Apache Royale Compiler from org/apache/royale/test/listeners/BrowserConsoleListener.as
 * org.apache.royale.test.listeners.BrowserConsoleListener
 *
 * @fileoverview
 *
 * @suppress {checkTypes|accessControls}
 */

goog.provide('org.apache.royale.test.listeners.BrowserConsoleListener');
goog.provide('org.apache.royale.test.listeners.BrowserConsoleListener.tracer');

goog.require('org.apache.royale.test.AssertionError');
goog.require('org.apache.royale.test.runners.notification.Failure');
goog.require('org.apache.royale.test.runners.notification.Result');
goog.require('org.apache.royale.test.runners.notification.IRunListener');
goog.require('org.apache.royale.utils.Language');



/**
 * @asprivate
 * @constructor
 * @implements {org.apache.royale.test.runners.notification.IRunListener}
 */
org.apache.royale.test.listeners.BrowserConsoleListener = function() {
};


/**
 * Prevent renaming of class. Needed for reflection.
 */
goog.exportSymbol('org.apache.royale.test.listeners.BrowserConsoleListener', org.apache.royale.test.listeners.BrowserConsoleListener);


/**
 * @protected
 * @type {number}
 */
org.apache.royale.test.listeners.BrowserConsoleListener.prototype._startTime = 0;


/**
 * @protected
 * @type {number}
 */
org.apache.royale.test.listeners.BrowserConsoleListener.prototype._testCount = 0;


/**
 * @protected
 * @type {number}
 */
org.apache.royale.test.listeners.BrowserConsoleListener.prototype._ignoreCount = 0;


/**
 * @protected
 * @type {Array.<org.apache.royale.test.runners.notification.Failure>}
 */
org.apache.royale.test.listeners.BrowserConsoleListener.prototype._failures = null;


/**
 * @asprivate
 * @export
 * @param {string} description
 */
org.apache.royale.test.listeners.BrowserConsoleListener.prototype.testStarted = function(description) {
  org.apache.royale.test.listeners.BrowserConsoleListener.tracer(description + " .");
};


/**
 * @asprivate
 * @export
 * @param {string} description
 */
org.apache.royale.test.listeners.BrowserConsoleListener.prototype.testFinished = function(description) {
  this._testCount++;
};


/**
 * @asprivate
 * @export
 * @param {org.apache.royale.test.runners.notification.Failure} failure
 */
org.apache.royale.test.listeners.BrowserConsoleListener.prototype.testFailure = function(failure) {
  this._failures.push(failure);
  var /** @type {Error} */ error = failure.exception;
  if (org.apache.royale.utils.Language.is(error, org.apache.royale.test.AssertionError)) {
    org.apache.royale.test.listeners.BrowserConsoleListener.tracer(failure.description + " F");
  } else {
    org.apache.royale.test.listeners.BrowserConsoleListener.tracer(failure.description + " E");
  }
};


/**
 * @asprivate
 * @export
 * @param {string} description
 */
org.apache.royale.test.listeners.BrowserConsoleListener.prototype.testIgnored = function(description) {
  this._ignoreCount++;
  org.apache.royale.test.listeners.BrowserConsoleListener.tracer(description + " I");
};


/**
 * @asprivate
 * @export
 * @param {string} description
 */
org.apache.royale.test.listeners.BrowserConsoleListener.prototype.testRunStarted = function(description) {
  this._startTime = new Date().getTime();
  this._testCount = 0;
  this._ignoreCount = 0;
  this._failures = org.apache.royale.utils.Language.synthVector('org.apache.royale.test.runners.notification.Failure')['coerce']([]);
};


/**
 * @asprivate
 * @export
 * @param {org.apache.royale.test.runners.notification.Result} result
 */
org.apache.royale.test.listeners.BrowserConsoleListener.prototype.testRunFinished = function(result) {
  var /** @type {number} */ totalTime = (new Date().getTime() - this._startTime) / 1000;
  org.apache.royale.test.listeners.BrowserConsoleListener.tracer("Time: " + totalTime);
  if (this._failures.length > 0) {
    if (this._failures.length === 1) {
      org.apache.royale.test.listeners.BrowserConsoleListener.tracer("There was 1 failure:");
    } else {
      org.apache.royale.test.listeners.BrowserConsoleListener.tracer("There were " + this._failures.length + " failures:");
    }
    for (var /** @type {number} */ i = 0; i < this._failures.length; i++) {
      org.apache.royale.test.listeners.BrowserConsoleListener.tracer((i + 1) + " " + this.getFailureMessage(this._failures[i]));
    }
  }
  var /** @type {string} */ testString = "tests";
  if (this._testCount === 1) {
    testString = "test";
  }
  if (this._ignoreCount > 0) {
    testString += ", " + this._ignoreCount + " ignored";
  }
  if (this._failures.length > 0) {
    var /** @type {string} */ failureString = "failures";
    if (this._failures.length === 1) {
      failureString = "failure";
    }
    org.apache.royale.test.listeners.BrowserConsoleListener.tracer("FAILURE (" + this._testCount + " " + testString + ", " + this._failures.length + " " + failureString + ")");
  } else {
    org.apache.royale.test.listeners.BrowserConsoleListener.tracer("OK (" + this._testCount + " " + testString + ")");
  }
};


/**
 * @asprivate
 * @protected
 * @param {org.apache.royale.test.runners.notification.Failure} failure
 * @return {string}
 */
org.apache.royale.test.listeners.BrowserConsoleListener.prototype.getFailureMessage = function(failure) {
  var /** @type {string} */ message = failure.description;
  var /** @type {Error} */ exception = failure.exception;
  if (exception.stack) {
    message += " " + exception.message + "\n" + exception.stack;
  } else if (exception.message) {
    message += " " + exception.message;
  } else {
    message += " " + exception;
  }
  return message;
};


/**
 * Metadata
 *
 * @type {Object.<string, Array.<Object>>}
 */
org.apache.royale.test.listeners.BrowserConsoleListener.prototype.ROYALE_CLASS_INFO = { names: [{ name: 'BrowserConsoleListener', qName: 'org.apache.royale.test.listeners.BrowserConsoleListener', kind: 'class' }], interfaces: [org.apache.royale.test.runners.notification.IRunListener] };



/**
 * Reflection
 *
 * @return {Object.<string, Function>}
 */
org.apache.royale.test.listeners.BrowserConsoleListener.prototype.ROYALE_REFLECTION_INFO = function () {
  return {
    methods: function () {
      return {
        'BrowserConsoleListener': { type: '', declaredBy: 'org.apache.royale.test.listeners.BrowserConsoleListener'},
        'testStarted': { type: 'void', declaredBy: 'org.apache.royale.test.listeners.BrowserConsoleListener', parameters: function () { return [ 'String', false ]; }},
        'testFinished': { type: 'void', declaredBy: 'org.apache.royale.test.listeners.BrowserConsoleListener', parameters: function () { return [ 'String', false ]; }},
        'testFailure': { type: 'void', declaredBy: 'org.apache.royale.test.listeners.BrowserConsoleListener', parameters: function () { return [ 'org.apache.royale.test.runners.notification.Failure', false ]; }},
        'testIgnored': { type: 'void', declaredBy: 'org.apache.royale.test.listeners.BrowserConsoleListener', parameters: function () { return [ 'String', false ]; }},
        'testRunStarted': { type: 'void', declaredBy: 'org.apache.royale.test.listeners.BrowserConsoleListener', parameters: function () { return [ 'String', false ]; }},
        'testRunFinished': { type: 'void', declaredBy: 'org.apache.royale.test.listeners.BrowserConsoleListener', parameters: function () { return [ 'org.apache.royale.test.runners.notification.Result', false ]; }}
      };
    }
  };
};
/**
 * @const
 * @type {number}
 */
org.apache.royale.test.listeners.BrowserConsoleListener.prototype.ROYALE_COMPILE_FLAGS = 10;



/**
 * @export
 * @param {...} args
 */
org.apache.royale.test.listeners.BrowserConsoleListener.tracer = function(args) {
  args = Array.prototype.slice.call(arguments, 0);
  args.unshift('[JS]');
  console.log.apply(console, args);
  
}