/**
 * Generated by Apache Royale Compiler from org/apache/royale/test/listeners/CIListener.as
 * org.apache.royale.test.listeners.CIListener
 *
 * @fileoverview
 *
 * @suppress {checkTypes|accessControls}
 */

goog.provide('org.apache.royale.test.listeners.CIListener');
goog.provide('org.apache.royale.test.listeners.CIListener.Descriptor');

goog.require('org.apache.royale.events.Event');
goog.require('org.apache.royale.events.EventDispatcher');
goog.require('org.apache.royale.test.AssertionError');
goog.require('org.apache.royale.test.runners.notification.Failure');
goog.require('org.apache.royale.test.runners.notification.Result');
goog.require('org.apache.royale.utils.Timer');
goog.require('org.apache.royale.test.runners.notification.IAsyncStartupRunListener');
goog.require('org.apache.royale.utils.Language');



/**
 * Constructor.
 * @constructor
 * @extends {org.apache.royale.events.EventDispatcher}
 * @implements {org.apache.royale.test.runners.notification.IAsyncStartupRunListener}
 * @param {number=} port
 * @param {string=} server
 */
org.apache.royale.test.listeners.CIListener = function(port, server) {
  org.apache.royale.test.listeners.CIListener.base(this, 'constructor');
  port = typeof port !== 'undefined' ? port : org.apache.royale.test.listeners.CIListener.DEFAULT_PORT;
  server = typeof server !== 'undefined' ? server : org.apache.royale.test.listeners.CIListener.DEFAULT_SERVER;
  this._port = port;
  this._server = server;
  
  this._socket = new WebSocket("ws://" + server + ":" + port);
  this._socket.addEventListener("open", org.apache.royale.utils.Language.closure(this.webSocket_openHandler, this, 'webSocket_openHandler'));
  this._socket.addEventListener("error", org.apache.royale.utils.Language.closure(this.socket_errorHandler, this, 'socket_errorHandler'));
  this._socket.addEventListener("message", org.apache.royale.utils.Language.closure(this.webSocket_messageHandler, this, 'webSocket_messageHandler'));
  this.socketTimeOutTimer = new org.apache.royale.utils.Timer(2000, 1);
  this.socketTimeOutTimer.addEventListener(org.apache.royale.utils.Timer.TIMER, org.apache.royale.utils.Language.closure(this.socketTimeOutTimer_timerHandler, this, 'socketTimeOutTimer_timerHandler'));
  this.socketTimeOutTimer.start();
  try {
    
    this.socketTimeOutTimer.stop();
  } catch (e) {
    org.apache.royale.utils.Language.trace(e.message);
  }
};
goog.inherits(org.apache.royale.test.listeners.CIListener, org.apache.royale.events.EventDispatcher);


/**
 * Prevent renaming of class. Needed for reflection.
 */
goog.exportSymbol('org.apache.royale.test.listeners.CIListener', org.apache.royale.test.listeners.CIListener);


/**
 * @protected
 * @nocollapse
 * @const
 * @type {number}
 */
org.apache.royale.test.listeners.CIListener.DEFAULT_PORT = 1024;


/**
 * @protected
 * @nocollapse
 * @const
 * @type {string}
 */
org.apache.royale.test.listeners.CIListener.DEFAULT_SERVER = "127.0.0.1";


/**
 * @protected
 * @nocollapse
 * @const
 * @type {string}
 */
org.apache.royale.test.listeners.CIListener.STATUS_SUCCESS = "success";


/**
 * @protected
 * @nocollapse
 * @const
 * @type {string}
 */
org.apache.royale.test.listeners.CIListener.STATUS_ERROR = "error";


/**
 * @protected
 * @nocollapse
 * @const
 * @type {string}
 */
org.apache.royale.test.listeners.CIListener.STATUS_FAILURE = "failure";


/**
 * @protected
 * @nocollapse
 * @const
 * @type {string}
 */
org.apache.royale.test.listeners.CIListener.STATUS_IGNORE = "ignore";


/**
 * @protected
 * @nocollapse
 * @const
 * @type {string}
 */
org.apache.royale.test.listeners.CIListener.END_OF_TEST_RUN = "<endOfTestRun/>";


/**
 * @protected
 * @nocollapse
 * @const
 * @type {string}
 */
org.apache.royale.test.listeners.CIListener.END_OF_TEST_ACK = "<endOfTestRunAck/>";


/**
 * @protected
 * @nocollapse
 * @const
 * @type {string}
 */
org.apache.royale.test.listeners.CIListener.START_OF_TEST_RUN_ACK = "<startOfTestRunAck/>";


/**
 * @protected
 * @type {WebSocket}
 */
org.apache.royale.test.listeners.CIListener.prototype._socket;


/**
 * @protected
 * @type {number}
 */
org.apache.royale.test.listeners.CIListener.prototype._port = 0;


/**
 * @protected
 * @type {string}
 */
org.apache.royale.test.listeners.CIListener.prototype._server;


/**
 * @protected
 * @type {boolean}
 */
org.apache.royale.test.listeners.CIListener.prototype.lastTestFailed = false;


/**
 * @protected
 * @type {org.apache.royale.utils.Timer}
 */
org.apache.royale.test.listeners.CIListener.prototype.socketTimeOutTimer = null;


/**
 * @protected
 * @type {number}
 */
org.apache.royale.test.listeners.CIListener.prototype.lastTestTime = 123;


/**
 * @protected
 * @type {boolean}
 */
org.apache.royale.test.listeners.CIListener.prototype._ready = false;


/**
 * @asprivate
 * @export
 * @param {string} description
 * @param {number} runTime
 */
org.apache.royale.test.listeners.CIListener.prototype.testTimed = function(description, runTime) {
  if (!runTime || isNaN(runTime)) {
    this.lastTestTime = 0;
  } else {
    this.lastTestTime = runTime;
  }
};


/**
 * @asprivate
 * @export
 * @param {string} description
 */
org.apache.royale.test.listeners.CIListener.prototype.testRunStarted = function(description) {
};


/**
 * @asprivate
 * @export
 * @param {org.apache.royale.test.runners.notification.Result} result
 */
org.apache.royale.test.listeners.CIListener.prototype.testRunFinished = function(result) {
  this.sendResults(org.apache.royale.test.listeners.CIListener.END_OF_TEST_RUN);
};


/**
 * @asprivate
 * @export
 * @param {string} description
 */
org.apache.royale.test.listeners.CIListener.prototype.testStarted = function(description) {
  this.lastTestFailed = false;
};


/**
 * @asprivate
 * @export
 * @param {string} description
 */
org.apache.royale.test.listeners.CIListener.prototype.testFinished = function(description) {
  if (this.lastTestFailed) {
    return;
  }
  var /** @type {org.apache.royale.test.listeners.CIListener.Descriptor} */ descriptor = this.org_apache_royale_test_listeners_CIListener_getDescriptorFromDescription(description);
  var /** @type {string} */ xml = "<testcase" + " classname=\"" + this.escapeXML(descriptor.suite) + "\"" + " name=\"" + this.escapeXML(descriptor.method) + "\"" + " time=\"" + this.lastTestTime + "\"" + " status=\"" + org.apache.royale.test.listeners.CIListener.STATUS_SUCCESS + "\"" + " />";
  this.sendResults(xml);
};


/**
 * @asprivate
 * @protected
 * @param {string} value
 * @return {string}
 */
org.apache.royale.test.listeners.CIListener.prototype.escapeXML = function(value) {
  if (value == null) {
    return "";
  }
  
  var /** @type {XMLSerializer} */ serializer = new XMLSerializer();
  var /** @type {Text} */ textNode = document.createTextNode(value);
  return serializer.serializeToString(textNode);
};


/**
 * @asprivate
 * @export
 * @param {string} description
 */
org.apache.royale.test.listeners.CIListener.prototype.testIgnored = function(description) {
  var /** @type {org.apache.royale.test.listeners.CIListener.Descriptor} */ descriptor = this.org_apache_royale_test_listeners_CIListener_getDescriptorFromDescription(description);
  var /** @type {string} */ xml = "<testcase" + " classname=\"" + this.escapeXML(descriptor.suite) + "\"" + " name=\"" + this.escapeXML(descriptor.method) + "\"" + " time=\"0\"" + " status=\"" + org.apache.royale.test.listeners.CIListener.STATUS_IGNORE + "\"" + ">" + "<skipped />" + "</testcase>";
  this.sendResults(xml);
};


/**
 * @asprivate
 * @export
 * @param {org.apache.royale.test.runners.notification.Failure} failure
 */
org.apache.royale.test.listeners.CIListener.prototype.testFailure = function(failure) {
  this.lastTestFailed = true;
  var /** @type {org.apache.royale.test.listeners.CIListener.Descriptor} */ descriptor = this.org_apache_royale_test_listeners_CIListener_getDescriptorFromDescription(failure.description);
  var /** @type {string} */ xml = null;
  if (org.apache.royale.utils.Language.is(failure.exception, org.apache.royale.test.AssertionError)) {
    xml = "<testcase" + " classname=\"" + this.escapeXML(descriptor.suite) + "\"" + " name=\"" + this.escapeXML(descriptor.method) + "\"" + " time=\"" + this.lastTestTime + "\"" + " status=\"" + org.apache.royale.test.listeners.CIListener.STATUS_FAILURE + "\"" + ">" + "<failure" + " message=\"" + this.escapeXML(failure.message) + "\"" + " type=\"" + this.escapeXML(failure.description) + "\"" + ">" + "<![CDATA[" + failure.stackTrace + "]]>" + "</failure>" + "</testcase>";
  } else {
    xml = "<testcase" + " classname=\"" + this.escapeXML(descriptor.suite) + "\"" + " name=\"" + this.escapeXML(descriptor.method) + "\"" + " time=\"" + this.lastTestTime + "\"" + " status=\"" + org.apache.royale.test.listeners.CIListener.STATUS_ERROR + "\"" + ">" + "<error" + " message=\"" + this.escapeXML(failure.message) + "\"" + " type=\"" + this.escapeXML(failure.description) + "\"" + ">" + "<![CDATA[" + failure.stackTrace + "]]>" + "</error>" + "</testcase>";
  }
  this.sendResults(xml);
};


/**
 * @asprivate
 * @private
 * @param {string} description
 * @return {org.apache.royale.test.listeners.CIListener.Descriptor}
 */
org.apache.royale.test.listeners.CIListener.prototype.org_apache_royale_test_listeners_CIListener_getDescriptorFromDescription = function(description) {
  var /** @type {org.apache.royale.test.listeners.CIListener.Descriptor} */ descriptor = new org.apache.royale.test.listeners.CIListener.Descriptor();
  var /** @type {Array} */ descriptionArray = description.split("::");
  var /** @type {string} */ classMethod;
  if (descriptionArray.length > 1) {
    descriptor.path = org.apache.royale.utils.Language.string(descriptionArray[0]);
    classMethod = org.apache.royale.utils.Language.string(descriptionArray[1]);
  } else {
    classMethod = org.apache.royale.utils.Language.string(descriptionArray[0]);
  }
  var /** @type {Array} */ classMethodArray = classMethod.split(".");
  if (descriptor.path == "") {
    descriptor.suite = org.apache.royale.utils.Language.string(classMethodArray[0]);
  } else {
    descriptor.suite = descriptor.path + "::" + classMethodArray[0];
  }
  if (classMethodArray.length > 1) {
    descriptor.method = org.apache.royale.utils.Language.string(classMethodArray[1]);
  } else {
    descriptor.method = "";
  }
  return descriptor;
};


/**
 * @asprivate
 * @protected
 * @param {string} msg
 */
org.apache.royale.test.listeners.CIListener.prototype.sendResults = function(msg) {
  
  if (this._socket.readyState == 1) {
    this._socket.send(msg);
  }
  org.apache.royale.utils.Language.trace(msg);
};


/**
 * @asprivate
 * @protected
 * @param {org.apache.royale.events.Event} event
 */
org.apache.royale.test.listeners.CIListener.prototype.socketTimeOutTimer_timerHandler = function(event) {
  org.apache.royale.utils.Language.trace("Socket timeout in CIListener");
  this.dispatchEvent(new org.apache.royale.events.Event("skip"));
};


/**
 * @asprivate
 * @protected
 * @param {Event} event
 */
org.apache.royale.test.listeners.CIListener.prototype.webSocket_openHandler = function(event) {
};


/**
 * @asprivate
 * @protected
 * @param {Object} event
 */
org.apache.royale.test.listeners.CIListener.prototype.socket_errorHandler = function(event) {
  org.apache.royale.utils.Language.trace("Socket error in CIListener");
  org.apache.royale.utils.Language.trace(event);
  this.dispatchEvent(new org.apache.royale.events.Event("skip"));
};


/**
 * @asprivate
 * @protected
 * @param {MessageEvent} event
 */
org.apache.royale.test.listeners.CIListener.prototype.webSocket_messageHandler = function(event) {
  var /** @type {string} */ data = org.apache.royale.utils.Language.as(event.data, String);
  if (data == org.apache.royale.test.listeners.CIListener.START_OF_TEST_RUN_ACK) {
    this._ready = true;
    this.dispatchEvent(new org.apache.royale.events.Event("ready"));
  } else if (data == org.apache.royale.test.listeners.CIListener.END_OF_TEST_ACK) {
    this._socket.close();
  }
};


org.apache.royale.test.listeners.CIListener.prototype.get__ready = function() {
  return this._ready;
};


Object.defineProperties(org.apache.royale.test.listeners.CIListener.prototype, /** @lends {org.apache.royale.test.listeners.CIListener.prototype} */ {
/**
  * @export
  * @type {boolean} */
ready: {
get: org.apache.royale.test.listeners.CIListener.prototype.get__ready}}
);


/**
 * Metadata
 *
 * @type {Object.<string, Array.<Object>>}
 */
org.apache.royale.test.listeners.CIListener.prototype.ROYALE_CLASS_INFO = { names: [{ name: 'CIListener', qName: 'org.apache.royale.test.listeners.CIListener', kind: 'class' }], interfaces: [org.apache.royale.test.runners.notification.IAsyncStartupRunListener] };



/**
 * Reflection
 *
 * @return {Object.<string, Function>}
 */
org.apache.royale.test.listeners.CIListener.prototype.ROYALE_REFLECTION_INFO = function () {
  return {
    accessors: function () {
      return {
        'ready': { type: 'Boolean', access: 'readonly', declaredBy: 'org.apache.royale.test.listeners.CIListener'}
      };
    },
    methods: function () {
      return {
        'CIListener': { type: '', declaredBy: 'org.apache.royale.test.listeners.CIListener', parameters: function () { return [ 'uint', true ,'String', true ]; }},
        'testTimed': { type: 'void', declaredBy: 'org.apache.royale.test.listeners.CIListener', parameters: function () { return [ 'String', false ,'Number', false ]; }},
        'testRunStarted': { type: 'void', declaredBy: 'org.apache.royale.test.listeners.CIListener', parameters: function () { return [ 'String', false ]; }},
        'testRunFinished': { type: 'void', declaredBy: 'org.apache.royale.test.listeners.CIListener', parameters: function () { return [ 'org.apache.royale.test.runners.notification.Result', false ]; }},
        'testStarted': { type: 'void', declaredBy: 'org.apache.royale.test.listeners.CIListener', parameters: function () { return [ 'String', false ]; }},
        'testFinished': { type: 'void', declaredBy: 'org.apache.royale.test.listeners.CIListener', parameters: function () { return [ 'String', false ]; }},
        'testIgnored': { type: 'void', declaredBy: 'org.apache.royale.test.listeners.CIListener', parameters: function () { return [ 'String', false ]; }},
        'testFailure': { type: 'void', declaredBy: 'org.apache.royale.test.listeners.CIListener', parameters: function () { return [ 'org.apache.royale.test.runners.notification.Failure', false ]; }}
      };
    }
  };
};
/**
 * @const
 * @type {number}
 */
org.apache.royale.test.listeners.CIListener.prototype.ROYALE_COMPILE_FLAGS = 10;



/**
 * @constructor
 * @param {string=} path
 * @param {string=} suite
 * @param {string=} method
 */
org.apache.royale.test.listeners.CIListener.Descriptor = function(path, suite, method) {
  path = typeof path !== 'undefined' ? path : "";
  suite = typeof suite !== 'undefined' ? suite : "";
  method = typeof method !== 'undefined' ? method : "";
  this.path = path;
  this.suite = suite;
  this.method = method;
};


/**
 * Prevent renaming of class. Needed for reflection.
 */
goog.exportSymbol('org.apache.royale.test.listeners.CIListener.Descriptor', org.apache.royale.test.listeners.CIListener.Descriptor);


/**
 * @export
 * @type {string}
 */
org.apache.royale.test.listeners.CIListener.Descriptor.prototype.path;


/**
 * @export
 * @type {string}
 */
org.apache.royale.test.listeners.CIListener.Descriptor.prototype.suite;


/**
 * @export
 * @type {string}
 */
org.apache.royale.test.listeners.CIListener.Descriptor.prototype.method;


/**
 * Metadata
 *
 * @type {Object.<string, Array.<Object>>}
 */
org.apache.royale.test.listeners.CIListener.Descriptor.prototype.ROYALE_CLASS_INFO = { names: [{ name: 'Descriptor', qName: 'org.apache.royale.test.listeners.CIListener.Descriptor', kind: 'class' }] };



/**
 * Reflection
 *
 * @return {Object.<string, Function>}
 */
org.apache.royale.test.listeners.CIListener.Descriptor.prototype.ROYALE_REFLECTION_INFO = function () {
  return {
    variables: function () {
      return {
        'path': { type: 'String', get_set: function (/** org.apache.royale.test.listeners.CIListener.Descriptor */ inst, /** * */ v) {return v !== undefined ? inst.path = v : inst.path;}},
        'suite': { type: 'String', get_set: function (/** org.apache.royale.test.listeners.CIListener.Descriptor */ inst, /** * */ v) {return v !== undefined ? inst.suite = v : inst.suite;}},
        'method': { type: 'String', get_set: function (/** org.apache.royale.test.listeners.CIListener.Descriptor */ inst, /** * */ v) {return v !== undefined ? inst.method = v : inst.method;}}
      };
    },
    methods: function () {
      return {
        'Descriptor': { type: '', declaredBy: 'org.apache.royale.test.listeners.CIListener.Descriptor', parameters: function () { return [ 'String', true ,'String', true ,'String', true ]; }}
      };
    }
  };
};
/**
 * @const
 * @type {number}
 */
org.apache.royale.test.listeners.CIListener.Descriptor.prototype.ROYALE_COMPILE_FLAGS = 10;