/**
 * Generated by Apache Royale Compiler from org/apache/royale/test/runners/MetadataRunner.as
 * org.apache.royale.test.runners.MetadataRunner
 *
 * @fileoverview
 *
 * @suppress {checkTypes|accessControls}
 */

goog.provide('org.apache.royale.test.runners.MetadataRunner');
goog.provide('org.apache.royale.test.runners.MetadataRunner.AsyncHandler');
goog.provide('org.apache.royale.test.runners.MetadataRunner.TestInfo');

goog.require('org.apache.royale.events.Event');
goog.require('org.apache.royale.reflection.MetaDataDefinition');
goog.require('org.apache.royale.reflection.MethodDefinition');
goog.require('org.apache.royale.reflection.TypeDefinition');
goog.require('org.apache.royale.reflection.describeType');
goog.require('org.apache.royale.reflection.getDefinitionByName');
goog.require('org.apache.royale.reflection.getQualifiedClassName');
goog.require('org.apache.royale.test.Assert');
goog.require('org.apache.royale.test.AssertionError');
goog.require('org.apache.royale.test.async.AsyncLocator');
goog.require('org.apache.royale.test.runners.TestMetadata');
goog.require('org.apache.royale.test.runners.notification.Failure');
goog.require('org.apache.royale.test.runners.notification.IRunListener');
goog.require('org.apache.royale.test.runners.notification.IRunNotifier');
goog.require('org.apache.royale.test.runners.notification.Result');
goog.require('org.apache.royale.utils.Timer');
goog.require('org.apache.royale.test.async.IAsyncHandler');
goog.require('org.apache.royale.test.runners.ITestRunner');
goog.require('org.apache.royale.utils.Language');



/**
 * Constructor.
 * @constructor
 * @implements {org.apache.royale.test.runners.ITestRunner}
 * @param {Object} testClass
 */
org.apache.royale.test.runners.MetadataRunner = function(testClass) {
  
  this._collectedTests = org.apache.royale.utils.Language.synthVector('org.apache.royale.test.runners.MetadataRunner.TestInfo')['coerce']([]);
  ;
  if (!testClass) {
    throw new Error("Test class must not be null.");
  }
  this._testClass = testClass;
};


/**
 * Prevent renaming of class. Needed for reflection.
 */
goog.exportSymbol('org.apache.royale.test.runners.MetadataRunner', org.apache.royale.test.runners.MetadataRunner);


/**
 * @export
 * @nocollapse
 * @const
 * @type {number}
 */
org.apache.royale.test.runners.MetadataRunner.DEFAULT_ASYNC_TIMEOUT = 500;


/**
 * @protected
 * @type {Object}
 */
org.apache.royale.test.runners.MetadataRunner.prototype._testClass = null;


/**
 * @protected
 * @type {boolean}
 */
org.apache.royale.test.runners.MetadataRunner.prototype._failures = false;


/**
 * @protected
 * @type {boolean}
 */
org.apache.royale.test.runners.MetadataRunner.prototype._stopRequested = false;


/**
 * @protected
 * @type {org.apache.royale.test.runners.notification.IRunNotifier}
 */
org.apache.royale.test.runners.MetadataRunner.prototype._notifier = null;


/**
 * @protected
 * @type {org.apache.royale.test.runners.notification.IRunListener}
 */
org.apache.royale.test.runners.MetadataRunner.prototype._listener = null;


/**
 * @protected
 * @type {Array.<org.apache.royale.test.runners.MetadataRunner.TestInfo>}
 */
org.apache.royale.test.runners.MetadataRunner.prototype._collectedTests;


/**
 * @protected
 * @type {number}
 */
org.apache.royale.test.runners.MetadataRunner.prototype._currentIndex = 0;


/**
 * @protected
 * @type {Object}
 */
org.apache.royale.test.runners.MetadataRunner.prototype._target = null;


/**
 * @protected
 * @type {org.apache.royale.test.runners.notification.Result}
 */
org.apache.royale.test.runners.MetadataRunner.prototype._result = null;


/**
 * @protected
 * @type {Function}
 */
org.apache.royale.test.runners.MetadataRunner.prototype._before = null;


/**
 * @protected
 * @type {Function}
 */
org.apache.royale.test.runners.MetadataRunner.prototype._after = null;


/**
 * @protected
 * @type {Function}
 */
org.apache.royale.test.runners.MetadataRunner.prototype._beforeClass = null;


/**
 * @protected
 * @type {Function}
 */
org.apache.royale.test.runners.MetadataRunner.prototype._afterClass = null;


/**
 * @protected
 * @type {org.apache.royale.utils.Timer}
 */
org.apache.royale.test.runners.MetadataRunner.prototype._timer = null;


/**
 * @inheritDoc
 * @export
 */
org.apache.royale.test.runners.MetadataRunner.prototype.pleaseStop = function() {
  this._stopRequested = true;
  if (this._timer) {
    this._timer.stop();
    this.cleanupAsync();
  }
};


/**
 * @inheritDoc
 * @export
 * @param {org.apache.royale.test.runners.notification.IRunNotifier} notifier
 */
org.apache.royale.test.runners.MetadataRunner.prototype.run = function(notifier) {
  this._notifier = notifier;
  this._failures = false;
  this._stopRequested = false;
  this._result = new org.apache.royale.test.runners.notification.Result();
  this._listener = this._result.createListener();
  this._notifier.addListener(this._listener);
  this._notifier.fireTestRunStarted(this.description);
  if (this._testClass) {
    this.readStaticMetadataTags();
    if (this._beforeClass !== null) {
      this._beforeClass.apply(this._testClass);
    }
    this._target = new this._testClass();
    this.readInstanceMetadataTags();
    this.continueAll();
  } else {
    this._failures = true;
    this._notifier.fireTestFailure(new org.apache.royale.test.runners.notification.Failure(this.description + ".initializationError", new Error("No tests specified.")));
    this._notifier.removeListener(this._listener);
    this._notifier.fireTestRunFinished(this._result);
  }
};


/**
 * @asprivate
 * @protected
 * @return {boolean}
 */
org.apache.royale.test.runners.MetadataRunner.prototype.checkForDone = function() {
  var /** @type {boolean} */ done = this._currentIndex >= this._collectedTests.length;
  if (!done) {
    return false;
  }
  if (this._afterClass !== null) {
    this._afterClass.apply(this._testClass);
  }
  this._notifier.removeListener(this._listener);
  this._notifier.fireTestRunFinished(this._result);
  return true;
};


/**
 * @asprivate
 * @protected
 */
org.apache.royale.test.runners.MetadataRunner.prototype.continueAll = function() {
  var /** @type {boolean} */ sync = true;
  while (sync && !this.checkForDone()) {
    sync = this.continueNext();
  }
};


/**
 * @asprivate
 * @protected
 * @return {boolean}
 */
org.apache.royale.test.runners.MetadataRunner.prototype.continueNext = function() {
  var /** @type {org.apache.royale.test.runners.MetadataRunner.TestInfo} */ test = this._collectedTests[this._currentIndex];
  try {
    if (test.ignore) {
      this._notifier.fireTestIgnored(test.description);
      this._currentIndex++;
      return true;
    }
    this._notifier.fireTestStarted(test.description);
    if (this._before !== null) {
      this._before.apply(this._target);
    }
    var /** @type {org.apache.royale.test.runners.MetadataRunner.AsyncHandler} */ asyncHandler = null;
    if (test.asyncTimeout > 0) {
      asyncHandler = new org.apache.royale.test.runners.MetadataRunner.AsyncHandler();
      org.apache.royale.test.async.AsyncLocator.setAsyncHandlerForTest(this._target, asyncHandler);
      asyncHandler.bodyExecuting = true;
    }
    if (test.expected != null) {
      var /** @type {Object} */ expectedType = org.apache.royale.utils.Language.as(org.apache.royale.reflection.getDefinitionByName(test.expected), org.apache.royale.utils.Language.synthType('Class'));
      var /** @type {Object} */ throwsType = null;
      try {
        test.reference.apply(this._target);
      } catch (exception) {
        throwsType = exception.constructor;
      }
      org.apache.royale.test.Assert.assertStrictlyEquals(throwsType, expectedType);
    } else {
      test.reference.apply(this._target);
    }
    if (asyncHandler) {
      asyncHandler.bodyExecuting = false;
      this._timer = new org.apache.royale.utils.Timer(test.asyncTimeout, 1);
      this._timer.addEventListener(org.apache.royale.utils.Timer.TIMER, org.apache.royale.utils.Language.closure(this.timer_timerHandler, this, 'timer_timerHandler'));
      this._timer.start();
      return false;
    }
  } catch (error) {
    this._failures = true;
    this._notifier.fireTestFailure(new org.apache.royale.test.runners.notification.Failure(test.description, error));
  }
  this.afterTest(test);
  return true;
};


/**
 * @protected
 * @param {org.apache.royale.test.runners.MetadataRunner.TestInfo} test
 */
org.apache.royale.test.runners.MetadataRunner.prototype.afterTest = function(test) {
  try {
    if (this._after !== null) {
      this._after.apply(this._target);
    }
  } catch (error) {
    this._failures = true;
    this._notifier.fireTestFailure(new org.apache.royale.test.runners.notification.Failure(test.description, error));
  }
  this._notifier.fireTestFinished(test.description);
  this._currentIndex++;
};


/**
 * @asprivate
 * @protected
 */
org.apache.royale.test.runners.MetadataRunner.prototype.readStaticMetadataTags = function() {
  var /** @type {org.apache.royale.reflection.MethodDefinition} */ beforeClassDefinition = this.collectMethodWithMetadataTag(org.apache.royale.test.runners.TestMetadata.BEFORE_CLASS, true);
  if (beforeClassDefinition != null) {
    this._beforeClass = this._testClass[beforeClassDefinition.name];
  }
  var /** @type {org.apache.royale.reflection.MethodDefinition} */ afterClassDefinition = this.collectMethodWithMetadataTag(org.apache.royale.test.runners.TestMetadata.AFTER_CLASS, true);
  if (afterClassDefinition != null) {
    this._afterClass = this._testClass[afterClassDefinition.name];
  }
  var /** @type {org.apache.royale.reflection.MethodDefinition} */ beforeDefinition = this.collectMethodWithMetadataTag(org.apache.royale.test.runners.TestMetadata.BEFORE, true);
  if (beforeDefinition != null) {
    this._failures = true;
    this._notifier.fireTestFailure(new org.apache.royale.test.runners.notification.Failure(this.description + ".initializationError", new Error("Unexpected [Before] metadata on static method <" + beforeDefinition.name + "> defined on type <" + beforeDefinition.declaredBy.qualifiedName + ">. [Before] may be used on instance methods only.")));
  }
  var /** @type {org.apache.royale.reflection.MethodDefinition} */ afterDefinition = this.collectMethodWithMetadataTag(org.apache.royale.test.runners.TestMetadata.AFTER, true);
  if (afterDefinition != null) {
    this._failures = true;
    this._notifier.fireTestFailure(new org.apache.royale.test.runners.notification.Failure(this.description + ".initializationError", new Error("Unexpected [After] metadata on static method <" + afterDefinition.name + "> defined on type <" + afterDefinition.declaredBy.qualifiedName + ">. [After] may be used on instance methods only.")));
  }
  var /** @type {org.apache.royale.reflection.MethodDefinition} */ testDefinition = this.collectMethodWithMetadataTag(org.apache.royale.test.runners.TestMetadata.TEST, true);
  if (testDefinition != null) {
    this._failures = true;
    this._notifier.fireTestFailure(new org.apache.royale.test.runners.notification.Failure(this.description + ".initializationError", new Error("Unexpected [Test] metadata on static method <" + testDefinition.name + "> defined on type <" + testDefinition.declaredBy.qualifiedName + ">. [Test] may be used on instance methods only.")));
  }
};


/**
 * @asprivate
 * @protected
 */
org.apache.royale.test.runners.MetadataRunner.prototype.readInstanceMetadataTags = function() {
  this.collectTests();
  if (this._collectedTests.length === 0) {
    throw new Error("No methods with [Test] metadata found on instance of type <" + org.apache.royale.reflection.getQualifiedClassName(this._testClass) + ">. Did you forget to include the -keep-as3-metadata compiler option?");
  }
  var /** @type {org.apache.royale.reflection.MethodDefinition} */ beforeDefinition = this.collectMethodWithMetadataTag(org.apache.royale.test.runners.TestMetadata.BEFORE);
  if (beforeDefinition != null) {
    this._before = this._target[beforeDefinition.name];
  }
  var /** @type {org.apache.royale.reflection.MethodDefinition} */ afterDefinition = this.collectMethodWithMetadataTag(org.apache.royale.test.runners.TestMetadata.AFTER);
  if (afterDefinition != null) {
    this._after = this._target[afterDefinition.name];
  }
  var /** @type {org.apache.royale.reflection.MethodDefinition} */ beforeClassDefinition = this.collectMethodWithMetadataTag(org.apache.royale.test.runners.TestMetadata.BEFORE_CLASS);
  if (beforeClassDefinition != null) {
    this._failures = true;
    this._notifier.fireTestFailure(new org.apache.royale.test.runners.notification.Failure(this.description + ".initializationError", new Error("Unexpected [BeforeClass] metadata on instance method <" + beforeClassDefinition.name + "> defined on type <" + beforeClassDefinition.declaredBy.qualifiedName + ">. [BeforeClass] may be used on static methods only.")));
  }
  var /** @type {org.apache.royale.reflection.MethodDefinition} */ afterClassDefinition = this.collectMethodWithMetadataTag(org.apache.royale.test.runners.TestMetadata.AFTER_CLASS);
  if (afterClassDefinition != null) {
    this._failures = true;
    this._notifier.fireTestFailure(new org.apache.royale.test.runners.notification.Failure(this.description + ".initializationError", new Error("Unexpected [AfterClass] metadata on instance method <" + afterClassDefinition.name + "> defined on type <" + afterClassDefinition.declaredBy.qualifiedName + ">. [AfterClass] may be used on static methods only.")));
  }
};


/**
 * @asprivate
 * @protected
 * @param {string} tagName
 * @param {boolean=} isStatic
 * @return {org.apache.royale.reflection.MethodDefinition}
 */
org.apache.royale.test.runners.MetadataRunner.prototype.collectMethodWithMetadataTag = function(tagName, isStatic) {
  isStatic = typeof isStatic !== 'undefined' ? isStatic : false;
  var /** @type {Object} */ described = isStatic ? this._testClass : this._target;
  var /** @type {org.apache.royale.reflection.TypeDefinition} */ typeDefinition = org.apache.royale.reflection.describeType(described);
  if (!typeDefinition) {
    return null;
  }
  var /** @type {Array} */ methods = isStatic ? typeDefinition.staticMethods : typeDefinition.methods;
  var /** @type {number} */ length = (methods.length) >> 0;
  for (var /** @type {number} */ i = 0; i < length; i++) {
    var /** @type {org.apache.royale.reflection.MethodDefinition} */ method = methods[i];
    var /** @type {Array} */ metadata = method.retrieveMetaDataByName(tagName);
    if (metadata.length > 0) {
      return method;
    }
  }
  return null;
};


/**
 * @asprivate
 * @protected
 */
org.apache.royale.test.runners.MetadataRunner.prototype.collectTests = function() {
  this._collectedTests[org.apache.royale.utils.Language.SYNTH_TAG_FIELD].length = 0;
  this._currentIndex = 0;
  var /** @type {org.apache.royale.reflection.TypeDefinition} */ typeDefinition = org.apache.royale.reflection.describeType(this._target);
  if (!typeDefinition) {
    return;
  }
  var /** @type {Array} */ methods = typeDefinition.methods;
  var /** @type {number} */ length = (methods.length) >> 0;
  for (var /** @type {number} */ i = 0; i < length; i++) {
    var /** @type {org.apache.royale.reflection.MethodDefinition} */ method = methods[i];
    var /** @type {string} */ testName = null;
    var /** @type {Function} */ testFunction = null;
    var /** @type {boolean} */ ignore = false;
    var /** @type {boolean} */ async = false;
    var /** @type {number} */ asyncTimeout = 0;
    var /** @type {string} */ expected = null;
    var /** @type {Array} */ testMetadata = method.retrieveMetaDataByName(org.apache.royale.test.runners.TestMetadata.TEST);
    if (testMetadata.length > 0) {
      var /** @type {org.apache.royale.reflection.MetaDataDefinition} */ testTag = testMetadata[0];
      var /** @type {string} */ qualifiedName = typeDefinition.qualifiedName;
      var /** @type {Array} */ qualifiedNameParts = qualifiedName.split(".");
      var /** @type {string} */ lastPart = org.apache.royale.utils.Language.string(qualifiedNameParts.pop());
      qualifiedName = qualifiedNameParts.join(".");
      if (qualifiedName.length > 0) {
        qualifiedName += "::";
      }
      qualifiedName += lastPart;
      testName = qualifiedName + "." + method.name;
      testFunction = this._target[method.name];
      if (testTag.getArgsByKey(org.apache.royale.test.runners.TestMetadata.TEST__ASYNC).length > 0) {
        var /** @type {Array} */ timeoutArgs = testTag.getArgsByKey(org.apache.royale.test.runners.TestMetadata.TEST__TIMEOUT);
        if (timeoutArgs.length > 0) {
          asyncTimeout = (parseFloat(timeoutArgs[0].value)) >> 0;
        } else {
          asyncTimeout = org.apache.royale.test.runners.MetadataRunner.DEFAULT_ASYNC_TIMEOUT;
        }
      }
      var /** @type {Array} */ expectedArgs = testTag.getArgsByKey(org.apache.royale.test.runners.TestMetadata.TEST__EXPECTED);
      if (expectedArgs.length > 0) {
        expected = org.apache.royale.utils.Language.string(expectedArgs[0].value);
      }
      var /** @type {Array} */ ignoreMetadata = method.retrieveMetaDataByName(org.apache.royale.test.runners.TestMetadata.IGNORE);
      if (ignoreMetadata.length > 0) {
        ignore = true;
      }
    }
    if (testName !== null) {
      this._collectedTests.push(new org.apache.royale.test.runners.MetadataRunner.TestInfo(testName, testFunction, ignore, asyncTimeout, expected));
    }
  }
};


/**
 * @asprivate
 * @protected
 */
org.apache.royale.test.runners.MetadataRunner.prototype.cleanupAsync = function() {
  this._timer.removeEventListener(org.apache.royale.utils.Timer.TIMER, org.apache.royale.utils.Language.closure(this.timer_timerHandler, this, 'timer_timerHandler'));
  this._timer = null;
  org.apache.royale.test.async.AsyncLocator.clearAsyncHandlerForTest(this._target);
};


/**
 * @asprivate
 * @protected
 * @param {org.apache.royale.events.Event} event
 */
org.apache.royale.test.runners.MetadataRunner.prototype.timer_timerHandler = function(event) {
  var /** @type {org.apache.royale.test.runners.MetadataRunner.AsyncHandler} */ asyncHandler = org.apache.royale.utils.Language.as(org.apache.royale.test.async.AsyncLocator.getAsyncHandlerForTest(this._target), org.apache.royale.test.runners.MetadataRunner.AsyncHandler, true);
  this.cleanupAsync();
  var /** @type {org.apache.royale.test.runners.MetadataRunner.TestInfo} */ test = this._collectedTests[this._currentIndex];
  if (asyncHandler.error) {
    this._failures = true;
    this._notifier.fireTestFailure(new org.apache.royale.test.runners.notification.Failure(test.description, asyncHandler.error));
  }
  if (asyncHandler.pendingCount > 0) {
    this._failures = true;
    this._notifier.fireTestFailure(new org.apache.royale.test.runners.notification.Failure(test.description, new org.apache.royale.test.AssertionError("Test did not complete within specified timeout " + test.asyncTimeout + "ms")));
  }
  this.afterTest(test);
  this.continueAll();
};


org.apache.royale.test.runners.MetadataRunner.prototype.get__description = function() {
  return org.apache.royale.reflection.getQualifiedClassName(this._testClass);
};


Object.defineProperties(org.apache.royale.test.runners.MetadataRunner.prototype, /** @lends {org.apache.royale.test.runners.MetadataRunner.prototype} */ {
/**
  * @export
  * @type {string} */
description: {
get: org.apache.royale.test.runners.MetadataRunner.prototype.get__description}}
);


/**
 * Metadata
 *
 * @type {Object.<string, Array.<Object>>}
 */
org.apache.royale.test.runners.MetadataRunner.prototype.ROYALE_CLASS_INFO = { names: [{ name: 'MetadataRunner', qName: 'org.apache.royale.test.runners.MetadataRunner', kind: 'class' }], interfaces: [org.apache.royale.test.runners.ITestRunner] };



/**
 * Reflection
 *
 * @return {Object.<string, Function>}
 */
org.apache.royale.test.runners.MetadataRunner.prototype.ROYALE_REFLECTION_INFO = function () {
  return {
    accessors: function () {
      return {
        'description': { type: 'String', access: 'readonly', declaredBy: 'org.apache.royale.test.runners.MetadataRunner'}
      };
    },
    methods: function () {
      return {
        'MetadataRunner': { type: '', declaredBy: 'org.apache.royale.test.runners.MetadataRunner', parameters: function () { return [ 'Class', false ]; }},
        'pleaseStop': { type: 'void', declaredBy: 'org.apache.royale.test.runners.MetadataRunner'},
        'run': { type: 'void', declaredBy: 'org.apache.royale.test.runners.MetadataRunner', parameters: function () { return [ 'org.apache.royale.test.runners.notification.IRunNotifier', false ]; }}
      };
    }
  };
};
/**
 * @const
 * @type {number}
 */
org.apache.royale.test.runners.MetadataRunner.prototype.ROYALE_COMPILE_FLAGS = 10;



/**
 * @constructor
 * @param {string} name
 * @param {Function} reference
 * @param {boolean} ignore
 * @param {number} asyncTimeout
 * @param {string} expected
 */
org.apache.royale.test.runners.MetadataRunner.TestInfo = function(name, reference, ignore, asyncTimeout, expected) {
  this.description = name;
  this.reference = reference;
  this.ignore = ignore;
  this.asyncTimeout = asyncTimeout;
  this.expected = expected;
};


/**
 * Prevent renaming of class. Needed for reflection.
 */
goog.exportSymbol('org.apache.royale.test.runners.MetadataRunner.TestInfo', org.apache.royale.test.runners.MetadataRunner.TestInfo);


/**
 * @export
 * @type {string}
 */
org.apache.royale.test.runners.MetadataRunner.TestInfo.prototype.description;


/**
 * @export
 * @type {Function}
 */
org.apache.royale.test.runners.MetadataRunner.TestInfo.prototype.reference;


/**
 * @export
 * @type {boolean}
 */
org.apache.royale.test.runners.MetadataRunner.TestInfo.prototype.ignore;


/**
 * @export
 * @type {number}
 */
org.apache.royale.test.runners.MetadataRunner.TestInfo.prototype.asyncTimeout = 0;


/**
 * @export
 * @type {string}
 */
org.apache.royale.test.runners.MetadataRunner.TestInfo.prototype.expected;


/**
 * Metadata
 *
 * @type {Object.<string, Array.<Object>>}
 */
org.apache.royale.test.runners.MetadataRunner.TestInfo.prototype.ROYALE_CLASS_INFO = { names: [{ name: 'TestInfo', qName: 'org.apache.royale.test.runners.MetadataRunner.TestInfo', kind: 'class' }] };



/**
 * Reflection
 *
 * @return {Object.<string, Function>}
 */
org.apache.royale.test.runners.MetadataRunner.TestInfo.prototype.ROYALE_REFLECTION_INFO = function () {
  return {
    variables: function () {
      return {
        'description': { type: 'String', get_set: function (/** org.apache.royale.test.runners.MetadataRunner.TestInfo */ inst, /** * */ v) {return v !== undefined ? inst.description = v : inst.description;}},
        'reference': { type: 'Function', get_set: function (/** org.apache.royale.test.runners.MetadataRunner.TestInfo */ inst, /** * */ v) {return v !== undefined ? inst.reference = v : inst.reference;}},
        'ignore': { type: 'Boolean', get_set: function (/** org.apache.royale.test.runners.MetadataRunner.TestInfo */ inst, /** * */ v) {return v !== undefined ? inst.ignore = v : inst.ignore;}},
        'asyncTimeout': { type: 'int', get_set: function (/** org.apache.royale.test.runners.MetadataRunner.TestInfo */ inst, /** * */ v) {return v !== undefined ? inst.asyncTimeout = v : inst.asyncTimeout;}},
        'expected': { type: 'String', get_set: function (/** org.apache.royale.test.runners.MetadataRunner.TestInfo */ inst, /** * */ v) {return v !== undefined ? inst.expected = v : inst.expected;}}
      };
    },
    methods: function () {
      return {
        'TestInfo': { type: '', declaredBy: 'org.apache.royale.test.runners.MetadataRunner.TestInfo', parameters: function () { return [ 'String', false ,'Function', false ,'Boolean', false ,'int', false ,'String', false ]; }}
      };
    }
  };
};
/**
 * @const
 * @type {number}
 */
org.apache.royale.test.runners.MetadataRunner.TestInfo.prototype.ROYALE_COMPILE_FLAGS = 10;



/**
 * @constructor
 * @implements {org.apache.royale.test.async.IAsyncHandler}
 */
org.apache.royale.test.runners.MetadataRunner.AsyncHandler = function() {

this.AsyncHandler__timers = org.apache.royale.utils.Language.synthVector('org.apache.royale.utils.Timer')['coerce']([]);
};


/**
 * Prevent renaming of class. Needed for reflection.
 */
goog.exportSymbol('org.apache.royale.test.runners.MetadataRunner.AsyncHandler', org.apache.royale.test.runners.MetadataRunner.AsyncHandler);


/**
 * @private
 * @type {boolean}
 */
org.apache.royale.test.runners.MetadataRunner.AsyncHandler.prototype.AsyncHandler__bodyExecuting = false;


/**
 * @private
 * @type {Error}
 */
org.apache.royale.test.runners.MetadataRunner.AsyncHandler.prototype.AsyncHandler__error = null;


/**
 * @private
 * @type {Array.<org.apache.royale.utils.Timer>}
 */
org.apache.royale.test.runners.MetadataRunner.AsyncHandler.prototype.AsyncHandler__timers;


/**
 * @export
 * @param {Function} callback
 * @param {number} delayMS
 */
org.apache.royale.test.runners.MetadataRunner.AsyncHandler.prototype.asyncHandler = function(callback, delayMS) {
  var self = this;
  var /** @type {number} */ timerIndex = -1;
  var /** @type {org.apache.royale.utils.Timer} */ timer = new org.apache.royale.utils.Timer(delayMS, 1);
  timer.addEventListener(org.apache.royale.utils.Timer.TIMER, function(event) {
    timer.removeEventListener(org.apache.royale.utils.Timer.TIMER, arguments["callee"]);
    var /** @type {number} */ index = self.AsyncHandler__timers.indexOf(timer);
    if (index !== -1) {
      self.AsyncHandler__timers.splice(index, 1);
    }
    try {
      callback();
    } catch (error) {
      self.AsyncHandler__error = error;
    }
  });
  this.AsyncHandler__timers.push(timer);
  timer.start();
};


org.apache.royale.test.runners.MetadataRunner.AsyncHandler.prototype.get__bodyExecuting = function() {
  return this.AsyncHandler__bodyExecuting;
};


org.apache.royale.test.runners.MetadataRunner.AsyncHandler.prototype.set__bodyExecuting = function(value) {
  this.AsyncHandler__bodyExecuting = value;
};


org.apache.royale.test.runners.MetadataRunner.AsyncHandler.prototype.get__error = function() {
  return this.AsyncHandler__error;
};


org.apache.royale.test.runners.MetadataRunner.AsyncHandler.prototype.get__pendingCount = function() {
  return (this.AsyncHandler__timers.length) >> 0;
};


Object.defineProperties(org.apache.royale.test.runners.MetadataRunner.AsyncHandler.prototype, /** @lends {org.apache.royale.test.runners.MetadataRunner.AsyncHandler.prototype} */ {
/**
  * @export
  * @type {boolean} */
bodyExecuting: {
get: org.apache.royale.test.runners.MetadataRunner.AsyncHandler.prototype.get__bodyExecuting,
set: org.apache.royale.test.runners.MetadataRunner.AsyncHandler.prototype.set__bodyExecuting},
/**
  * @export
  * @type {Error} */
error: {
get: org.apache.royale.test.runners.MetadataRunner.AsyncHandler.prototype.get__error},
/**
  * @export
  * @type {number} */
pendingCount: {
get: org.apache.royale.test.runners.MetadataRunner.AsyncHandler.prototype.get__pendingCount}}
);


/**
 * Metadata
 *
 * @type {Object.<string, Array.<Object>>}
 */
org.apache.royale.test.runners.MetadataRunner.AsyncHandler.prototype.ROYALE_CLASS_INFO = { names: [{ name: 'AsyncHandler', qName: 'org.apache.royale.test.runners.MetadataRunner.AsyncHandler', kind: 'class' }], interfaces: [org.apache.royale.test.async.IAsyncHandler] };



/**
 * Reflection
 *
 * @return {Object.<string, Function>}
 */
org.apache.royale.test.runners.MetadataRunner.AsyncHandler.prototype.ROYALE_REFLECTION_INFO = function () {
  return {
    accessors: function () {
      return {
        'bodyExecuting': { type: 'Boolean', access: 'readwrite', declaredBy: 'org.apache.royale.test.runners.MetadataRunner.AsyncHandler'},
        'error': { type: 'Error', access: 'readonly', declaredBy: 'org.apache.royale.test.runners.MetadataRunner.AsyncHandler'},
        'pendingCount': { type: 'int', access: 'readonly', declaredBy: 'org.apache.royale.test.runners.MetadataRunner.AsyncHandler'}
      };
    },
    methods: function () {
      return {
        'asyncHandler': { type: 'void', declaredBy: 'org.apache.royale.test.runners.MetadataRunner.AsyncHandler', parameters: function () { return [ 'Function', false ,'int', false ]; }}
      };
    }
  };
};
/**
 * @const
 * @type {number}
 */
org.apache.royale.test.runners.MetadataRunner.AsyncHandler.prototype.ROYALE_COMPILE_FLAGS = 10;