/**
 * Generated by Apache Royale Compiler from org/apache/royale/test/runners/ParentRunner.as
 * org.apache.royale.test.runners.ParentRunner
 *
 * @fileoverview
 *
 * @suppress {checkTypes|accessControls}
 */

goog.provide('org.apache.royale.test.runners.ParentRunner');
goog.provide('org.apache.royale.test.runners.ParentRunner.ChildNotifier');

goog.require('org.apache.royale.reflection.MetaDataArgDefinition');
goog.require('org.apache.royale.reflection.MetaDataDefinition');
goog.require('org.apache.royale.reflection.TypeDefinition');
goog.require('org.apache.royale.reflection.describeType');
goog.require('org.apache.royale.reflection.getDefinitionByName');
goog.require('org.apache.royale.test.runners.ITestRunner');
goog.require('org.apache.royale.test.runners.MetadataRunner');
goog.require('org.apache.royale.test.runners.SuiteRunner');
goog.require('org.apache.royale.test.runners.TestMetadata');
goog.require('org.apache.royale.test.runners.notification.Failure');
goog.require('org.apache.royale.test.runners.notification.IRunListener');
goog.require('org.apache.royale.test.runners.notification.IRunNotifier');
goog.require('org.apache.royale.test.runners.notification.Result');
goog.require('org.apache.royale.utils.Language');



/**
 * Constructor.
 * @constructor
 * @implements {org.apache.royale.test.runners.ITestRunner}
 * @param {Array.<Object>=} children
 */
org.apache.royale.test.runners.ParentRunner = function(children) {
  children = typeof children !== 'undefined' ? children : null;
  if (org.apache.royale.utils.Language.resolveUncertain(Object(this)).constructor === org.apache.royale.test.runners.ParentRunner) {
    throw new Error("Class ParentRunner is abstract");
  }
  this._children = children;
};


/**
 * Prevent renaming of class. Needed for reflection.
 */
goog.exportSymbol('org.apache.royale.test.runners.ParentRunner', org.apache.royale.test.runners.ParentRunner);


/**
 * @private
 * @type {org.apache.royale.test.runners.SuiteRunner}
 */
org.apache.royale.test.runners.ParentRunner._suiteRunner;


/**
 * @protected
 * @type {Array.<Object>}
 */
org.apache.royale.test.runners.ParentRunner.prototype._children = null;


/**
 * @protected
 * @type {org.apache.royale.test.runners.ITestRunner}
 */
org.apache.royale.test.runners.ParentRunner.prototype._currentRunner = null;


/**
 * @protected
 * @type {org.apache.royale.test.runners.notification.Result}
 */
org.apache.royale.test.runners.ParentRunner.prototype._result = null;


/**
 * @protected
 * @type {org.apache.royale.test.runners.notification.IRunNotifier}
 */
org.apache.royale.test.runners.ParentRunner.prototype._notifier = null;


/**
 * @protected
 * @type {boolean}
 */
org.apache.royale.test.runners.ParentRunner.prototype._failures = false;


/**
 * @protected
 * @type {boolean}
 */
org.apache.royale.test.runners.ParentRunner.prototype._stopRequested = false;


/**
 * @inheritDoc
 * @export
 */
org.apache.royale.test.runners.ParentRunner.prototype.pleaseStop = function() {
  this._stopRequested = true;
};


/**
 * @asprivate
 * @export
 * @param {org.apache.royale.test.runners.notification.IRunNotifier} notifier
 */
org.apache.royale.test.runners.ParentRunner.prototype.run = function(notifier) {
  this._failures = false;
  this._stopRequested = false;
  this._children = org.apache.royale.utils.Language.synthVector('Class')['coerce']([]);
  this._notifier = notifier;
  this._result = new org.apache.royale.test.runners.notification.Result();
  this._notifier.addListener(this._result.createListener());
  this._notifier.fireTestRunStarted(this.description);
  try {
    this.collectChildren(this._children);
  } catch (error) {
    this._failures = true;
    notifier.fireTestFailure(new org.apache.royale.test.runners.notification.Failure(this.description + ".initializationError", error));
  }
  if (this._children.length === 0) {
    this._failures = true;
    notifier.fireTestFailure(new org.apache.royale.test.runners.notification.Failure(this.description + ".initializationError", new Error("No children found")));
  }
  this.nextChild();
};


/**
 * @asprivate
 * @protected
 */
org.apache.royale.test.runners.ParentRunner.prototype.nextChild = function() {
  this._currentRunner = null;
  if (this._stopRequested) {
    this._failures = true;
    this._notifier.fireTestFailure(new org.apache.royale.test.runners.notification.Failure(this.description, new Error("Stop requested")));
    this._children[org.apache.royale.utils.Language.SYNTH_TAG_FIELD].length = 0;
  }
  if (this._children.length == 0) {
    var /** @type {org.apache.royale.test.runners.notification.IRunNotifier} */ notifier = this._notifier;
    var /** @type {org.apache.royale.test.runners.notification.Result} */ result = this._result;
    this._notifier = null;
    this._result = null;
    notifier.fireTestRunFinished(result);
    notifier.removeListener(result.createListener());
    return;
  }
  if ("requestAnimationFrame" in goog.global) {
    goog.global["requestAnimationFrame"](org.apache.royale.utils.Language.closure(this.createNextRunner, this, 'createNextRunner'));
  } else if ("setImmediate" in goog.global) {
    goog.global["setImmediate"](org.apache.royale.utils.Language.closure(this.createNextRunner, this, 'createNextRunner'));
  } else if ("setTimeout" in goog.global) {
    goog.global["setTimeout"](org.apache.royale.utils.Language.closure(this.createNextRunner, this, 'createNextRunner'), 0);
  } else {
    this.createNextRunner();
  }
  
};


/**
 * @asprivate
 * @protected
 */
org.apache.royale.test.runners.ParentRunner.prototype.createNextRunner = function() {
  var /** @type {org.apache.royale.test.runners.notification.IRunNotifier} */ notifier = this._notifier;
  var /** @type {Object} */ child = this._children.pop();
  try {
    this._currentRunner = this.createChildRunner(child);
    var /** @type {org.apache.royale.test.runners.ParentRunner.ChildNotifier} */ childNotifier = new org.apache.royale.test.runners.ParentRunner.ChildNotifier(this._notifier, org.apache.royale.utils.Language.closure(this.nextChild, this, 'nextChild'));
    this._currentRunner.run(childNotifier);
  } catch (error) {
    this._failures = true;
    notifier.fireTestFailure(new org.apache.royale.test.runners.notification.Failure(this.description, error));
    this.nextChild();
  }
};


/**
 * Subclasses must override to collect all children for this parent
 * runner.
 * @protected
 * @param {Array.<Object>} result
 */
org.apache.royale.test.runners.ParentRunner.prototype.collectChildren = function(result) {
  throw new Error("AbstractClassError: collectChildren() not implemented by <" + this + ">");
};


/**
 * @asprivate
 * @protected
 * @param {Object} child
 * @return {org.apache.royale.test.runners.ITestRunner}
 */
org.apache.royale.test.runners.ParentRunner.prototype.createChildRunner = function(child) {
  var /** @type {org.apache.royale.reflection.TypeDefinition} */ typeDefinition = org.apache.royale.reflection.describeType(child);
  if (!typeDefinition) {
    throw new Error("Could not find type definition for child <" + child + "> in test suite <" + this.description + ">");
  }
  var /** @type {Array} */ runWithMetadata = typeDefinition.retrieveMetaDataByName(org.apache.royale.test.runners.TestMetadata.RUN_WITH);
  if (runWithMetadata.length > 0) {
    var /** @type {Object} */ RunWithClass = this.verifyRunWith(typeDefinition);
    return new RunWithClass(child);
  } else {
    return new org.apache.royale.test.runners.MetadataRunner(child);
  }
};


/**
 * @asprivate
 * @protected
 * @param {org.apache.royale.reflection.TypeDefinition} typeDefinition
 * @return {Object}
 */
org.apache.royale.test.runners.ParentRunner.prototype.verifyRunWith = function(typeDefinition) {
  if (!typeDefinition) {
    throw new Error("No test runner type has been specified");
  }
  var /** @type {Array} */ runWithMetadata = typeDefinition.retrieveMetaDataByName(org.apache.royale.test.runners.TestMetadata.RUN_WITH);
  if (runWithMetadata.length === 0) {
    throw new Error("Missing [RunWith] metadata on test runner: <" + typeDefinition.qualifiedName + ">");
  }
  var /** @type {org.apache.royale.reflection.MetaDataDefinition} */ metadata = runWithMetadata[0];
  if (metadata.args.length !== 1) {
    throw new Error("Invalid class reference in [RunWith] metadata on test runner: <" + typeDefinition.qualifiedName + ">");
  }
  var /** @type {org.apache.royale.reflection.MetaDataArgDefinition} */ arg = metadata.args[0];
  if (arg.key) {
    throw new Error("Unknown key <" + arg.key + "> in [RunWith] metadata on test runner: <" + typeDefinition.qualifiedName + ">");
  }
  var /** @type {string} */ runWithClassName = arg.value;
  var /** @type {Object} */ RunWithClass = org.apache.royale.utils.Language.as(org.apache.royale.reflection.getDefinitionByName(runWithClassName), org.apache.royale.utils.Language.synthType('Class'));
  if (!RunWithClass) {
    throw new Error("Could not find test runner: <" + runWithClassName + ">");
  }
  return RunWithClass;
};


org.apache.royale.test.runners.ParentRunner.prototype.get__description = function() {
  throw new Error("AbstractClassError: get description not implemented by <" + this + ">");
};


Object.defineProperties(org.apache.royale.test.runners.ParentRunner.prototype, /** @lends {org.apache.royale.test.runners.ParentRunner.prototype} */ {
/**
  * @export
  * @type {string} */
description: {
get: org.apache.royale.test.runners.ParentRunner.prototype.get__description}}
);


/**
 * Metadata
 *
 * @type {Object.<string, Array.<Object>>}
 */
org.apache.royale.test.runners.ParentRunner.prototype.ROYALE_CLASS_INFO = { names: [{ name: 'ParentRunner', qName: 'org.apache.royale.test.runners.ParentRunner', kind: 'class' }], interfaces: [org.apache.royale.test.runners.ITestRunner] };



/**
 * Reflection
 *
 * @return {Object.<string, Function>}
 */
org.apache.royale.test.runners.ParentRunner.prototype.ROYALE_REFLECTION_INFO = function () {
  return {
    accessors: function () {
      return {
        'description': { type: 'String', access: 'readonly', declaredBy: 'org.apache.royale.test.runners.ParentRunner'}
      };
    },
    methods: function () {
      return {
        'ParentRunner': { type: '', declaredBy: 'org.apache.royale.test.runners.ParentRunner', parameters: function () { return [ 'Vector.<Class>', true ]; }},
        'pleaseStop': { type: 'void', declaredBy: 'org.apache.royale.test.runners.ParentRunner'},
        'run': { type: 'void', declaredBy: 'org.apache.royale.test.runners.ParentRunner', parameters: function () { return [ 'org.apache.royale.test.runners.notification.IRunNotifier', false ]; }}
      };
    }
  };
};
/**
 * @const
 * @type {number}
 */
org.apache.royale.test.runners.ParentRunner.prototype.ROYALE_COMPILE_FLAGS = 10;



/**
 * @constructor
 * @implements {org.apache.royale.test.runners.notification.IRunNotifier}
 * @param {org.apache.royale.test.runners.notification.IRunNotifier} parentNotifier
 * @param {Function} testRunFinishedCallback
 */
org.apache.royale.test.runners.ParentRunner.ChildNotifier = function(parentNotifier, testRunFinishedCallback) {
  this.ChildNotifier__parentNotifier = parentNotifier;
  this.ChildNotifier__testRunFinishedCallback = testRunFinishedCallback;
};


/**
 * Prevent renaming of class. Needed for reflection.
 */
goog.exportSymbol('org.apache.royale.test.runners.ParentRunner.ChildNotifier', org.apache.royale.test.runners.ParentRunner.ChildNotifier);


/**
 * @private
 * @type {org.apache.royale.test.runners.notification.IRunNotifier}
 */
org.apache.royale.test.runners.ParentRunner.ChildNotifier.prototype.ChildNotifier__parentNotifier;


/**
 * @private
 * @type {Function}
 */
org.apache.royale.test.runners.ParentRunner.ChildNotifier.prototype.ChildNotifier__testRunFinishedCallback;


/**
 * @export
 * @param {string} description
 */
org.apache.royale.test.runners.ParentRunner.ChildNotifier.prototype.fireTestStarted = function(description) {
  this.ChildNotifier__parentNotifier.fireTestStarted(description);
};


/**
 * @export
 * @param {string} description
 */
org.apache.royale.test.runners.ParentRunner.ChildNotifier.prototype.fireTestFinished = function(description) {
  this.ChildNotifier__parentNotifier.fireTestFinished(description);
};


/**
 * @export
 * @param {org.apache.royale.test.runners.notification.Failure} failure
 */
org.apache.royale.test.runners.ParentRunner.ChildNotifier.prototype.fireTestFailure = function(failure) {
  this.ChildNotifier__parentNotifier.fireTestFailure(failure);
};


/**
 * @export
 * @param {string} description
 */
org.apache.royale.test.runners.ParentRunner.ChildNotifier.prototype.fireTestIgnored = function(description) {
  this.ChildNotifier__parentNotifier.fireTestIgnored(description);
};


/**
 * @export
 * @param {string} description
 */
org.apache.royale.test.runners.ParentRunner.ChildNotifier.prototype.fireTestRunStarted = function(description) {
};


/**
 * @export
 * @param {org.apache.royale.test.runners.notification.Result} result
 */
org.apache.royale.test.runners.ParentRunner.ChildNotifier.prototype.fireTestRunFinished = function(result) {
  this.ChildNotifier__testRunFinishedCallback();
};


/**
 * @export
 * @param {org.apache.royale.test.runners.notification.IRunListener} listener
 */
org.apache.royale.test.runners.ParentRunner.ChildNotifier.prototype.addListener = function(listener) {
};


/**
 * @export
 * @param {org.apache.royale.test.runners.notification.IRunListener} listener
 */
org.apache.royale.test.runners.ParentRunner.ChildNotifier.prototype.addFirstListener = function(listener) {
};


/**
 * @export
 * @param {org.apache.royale.test.runners.notification.IRunListener} listener
 */
org.apache.royale.test.runners.ParentRunner.ChildNotifier.prototype.removeListener = function(listener) {
};


/**
 * @export
 */
org.apache.royale.test.runners.ParentRunner.ChildNotifier.prototype.removeAllListeners = function() {
};


/**
 * Metadata
 *
 * @type {Object.<string, Array.<Object>>}
 */
org.apache.royale.test.runners.ParentRunner.ChildNotifier.prototype.ROYALE_CLASS_INFO = { names: [{ name: 'ChildNotifier', qName: 'org.apache.royale.test.runners.ParentRunner.ChildNotifier', kind: 'class' }], interfaces: [org.apache.royale.test.runners.notification.IRunNotifier] };



/**
 * Reflection
 *
 * @return {Object.<string, Function>}
 */
org.apache.royale.test.runners.ParentRunner.ChildNotifier.prototype.ROYALE_REFLECTION_INFO = function () {
  return {
    methods: function () {
      return {
        'ChildNotifier': { type: '', declaredBy: 'org.apache.royale.test.runners.ParentRunner.ChildNotifier', parameters: function () { return [ 'org.apache.royale.test.runners.notification.IRunNotifier', false ,'Function', false ]; }},
        'fireTestStarted': { type: 'void', declaredBy: 'org.apache.royale.test.runners.ParentRunner.ChildNotifier', parameters: function () { return [ 'String', false ]; }},
        'fireTestFinished': { type: 'void', declaredBy: 'org.apache.royale.test.runners.ParentRunner.ChildNotifier', parameters: function () { return [ 'String', false ]; }},
        'fireTestFailure': { type: 'void', declaredBy: 'org.apache.royale.test.runners.ParentRunner.ChildNotifier', parameters: function () { return [ 'org.apache.royale.test.runners.notification.Failure', false ]; }},
        'fireTestIgnored': { type: 'void', declaredBy: 'org.apache.royale.test.runners.ParentRunner.ChildNotifier', parameters: function () { return [ 'String', false ]; }},
        'fireTestRunStarted': { type: 'void', declaredBy: 'org.apache.royale.test.runners.ParentRunner.ChildNotifier', parameters: function () { return [ 'String', false ]; }},
        'fireTestRunFinished': { type: 'void', declaredBy: 'org.apache.royale.test.runners.ParentRunner.ChildNotifier', parameters: function () { return [ 'org.apache.royale.test.runners.notification.Result', false ]; }},
        'addListener': { type: 'void', declaredBy: 'org.apache.royale.test.runners.ParentRunner.ChildNotifier', parameters: function () { return [ 'org.apache.royale.test.runners.notification.IRunListener', false ]; }},
        'addFirstListener': { type: 'void', declaredBy: 'org.apache.royale.test.runners.ParentRunner.ChildNotifier', parameters: function () { return [ 'org.apache.royale.test.runners.notification.IRunListener', false ]; }},
        'removeListener': { type: 'void', declaredBy: 'org.apache.royale.test.runners.ParentRunner.ChildNotifier', parameters: function () { return [ 'org.apache.royale.test.runners.notification.IRunListener', false ]; }},
        'removeAllListeners': { type: 'void', declaredBy: 'org.apache.royale.test.runners.ParentRunner.ChildNotifier'}
      };
    }
  };
};
/**
 * @const
 * @type {number}
 */
org.apache.royale.test.runners.ParentRunner.ChildNotifier.prototype.ROYALE_COMPILE_FLAGS = 10;